require "DAMN_Parts";
require "DAMN_Spawns";

--***********************************************************
--**                   KI5 / bikinihorst                   **
--***********************************************************

DAMN.Parts:processConfigV2("BUSH", {
	["Bullbar"] = {
		partId = "BUSHBullbar",
		itemToModel = {
			["Base.97BushBullbarSAS"] = "Bullbar0",
		},
		default = "trve_random",
		noPartChance = 50,
	},
	["SpareTire"] = {
		partId = "BUSHSpareRight",
		itemToModel = {
			["runFlat.ModernTire"] = "Bushspare1",
		},
		default = "trve_random",
		noPartChance = 5,
	},
	["SpareTireRoof"] = {
		partId = "BUSHSpareRoof",
		itemToModel = {
			["runFlat.ModernTire"] = "Bushspare2",
		},
		default = "trve_random",
		noPartChance = 85,
	},
	["LeftStorage"] = {
		partId = "BUSHStorageLeft",
		itemToModel = {
			["Base.97BushLeftStorage0"] = "Bushstorageleft0",
			["Base.Generator"] = "BushstorageleftG",
		},
		default = "trve_random",
		noPartChance = 5,
	},
	["RoofStorage"] = {
		partId = "BUSHRoofCrates",
		itemToModel = {
			["Base.97BushRoofStorage0"] = "Bushroof0",
		},
		default = "trve_random",
		noPartChance = 85,
	},
	["GasCanOne"] = {
		partId = "BUSHCanOne",
		itemToModel = {
			["USMIL.GasCan0"] = "GasCanOne",
			["USMIL.emptyGasCan0"] = "GasCanOneE",
			["USMIL.WaterCan0"] = "WaterCanOne",
			["USMIL.emptyWaterCan0"] = "WaterCanOneE",
		},
		default = "trve_random",
		noPartChance = 35,
	},
	["GasCanTwo"] = {
		partId = "BUSHCanTwo",
		itemToModel = {
			["USMIL.GasCan0"] = "GasCanTwo",
			["USMIL.emptyGasCan0"] = "GasCanTwoE",
			["USMIL.WaterCan0"] = "WaterCanTwo",
			["USMIL.emptyWaterCan0"] = "WaterCanTwoE",
		},
		default = "trve_random",
		noPartChance = 35,
	},
	["GasCanThree"] = {
		partId = "BUSHCanThree",
		itemToModel = {
			["USMIL.GasCan0"] = "GasCanThree",
			["USMIL.emptyGasCan0"] = "GasCanThreeE",
			["USMIL.WaterCan0"] = "WaterCanThree",
			["USMIL.emptyWaterCan0"] = "WaterCanThreeE",
		},
		default = "trve_random",
		noPartChance = 35,
	},
	["GasCanFour"] = {
		partId = "BUSHCanFour",
		itemToModel = {
			["USMIL.GasCan0"] = "GasCanFour",
			["USMIL.emptyGasCan0"] = "GasCanFourE",
			["USMIL.WaterCan0"] = "WaterCanFour",
			["USMIL.emptyWaterCan0"] = "WaterCanFourE",
		},
		default = "trve_random",
		noPartChance = 35,
	},
	["GasCanFive"] = {
		partId = "BUSHCanFive",
		itemToModel = {
			["USMIL.GasCan0"] = "GasCanFive",
			["USMIL.emptyGasCan0"] = "GasCanFiveE",
			["USMIL.WaterCan0"] = "WaterCanFive",
			["USMIL.emptyWaterCan0"] = "WaterCanFiveE",
		},
		default = "trve_random",
		noPartChance = 35,
	},
});

DAMN.Spawns:add("Base.97bushmaster", 12598, 939, {
    direction = IsoDirections.S, 
    chance = 75,
    skinIndex = 0,
    sandboxVar = "AllowBushmasterSpawns",
});

DAMN.Spawns:add("Base.97bushAmbulance", 12598, 930, {
    direction = IsoDirections.S, 
    chance = 75,
    skinIndex = 0,
    sandboxVar = "AllowBushmasterSpawns",
});

DAMN.Spawns:add("Base.97bushmaster", 5522, 12487, {
    direction = IsoDirections.N, 
    chance = 65,
    skinIndex = 4,
    sandboxVar = "AllowBushmasterSpawns",
});

DAMN.Spawns:add("Base.97bushmaster", 3004, 5790, {
    direction = IsoDirections.E, 
    chance = 65,
    skinIndex = 3,
    sandboxVar = "AllowBushmasterSpawns",
});

DAMN.Spawns:add("Base.97bushAmbulance", 3006, 5795, {
    direction = IsoDirections.E, 
    chance = 65,
    skinIndex = 3,
    sandboxVar = "AllowBushmasterSpawns",
});

DAMN.Spawns:add("Base.97bushAmbulance", 10009, 6300, {
    direction = IsoDirections.E, 
    chance = 50,
    sandboxVar = "AllowBushmasterSpawns",
});

DAMN.Spawns:add("Base.97bushAmbulance", 11187, 13036, {
    direction = IsoDirections.N, 
    chance = 75,
    skinIndex = 1,
    sandboxVar = "AllowBushmasterSpawns",
});

function BUSH.ContainerAccess.Trunk(vehicle, part, chr)
	if chr:getVehicle() == vehicle then
		local seat = vehicle:getSeat(chr)
		return seat <= 10;
	elseif chr:getVehicle() then
		return false
	else
		if not vehicle:isInArea(part:getArea(), chr) then return false end
		local doorPart = vehicle:getPartById("TrunkDoor")
		if doorPart and doorPart:getDoor() and not doorPart:getDoor():isOpen() then
			return false
		end
		return true
	end
end

function BUSH.ContainerAccess.Roofrack(vehicle, part, chr)
	if chr:getVehicle() then return false end
	if not vehicle:isInArea(part:getArea(), chr) then return false end
	return true
end

function BUSH.ContainerAccess.FL(vehicle, part, chr)
	if chr:getVehicle() then return false end
	if not vehicle:isInArea(part:getArea(), chr) then return false end
	local StorageLid1 = vehicle:getPartById("StorageLid1")
	if StorageLid1 and StorageLid1:getDoor() then
		if not StorageLid1:getInventoryItem() then return true end
		if not StorageLid1:getDoor():isOpen() then return false end
	end
	--
	return true
end

function BUSH.ContainerAccess.FR(vehicle, part, chr)
	if chr:getVehicle() then return false end
	if not vehicle:isInArea(part:getArea(), chr) then return false end
	local StorageLid2 = vehicle:getPartById("StorageLid2")
	if StorageLid2 and StorageLid2:getDoor() then
		if not StorageLid2:getInventoryItem() then return true end
		if not StorageLid2:getDoor():isOpen() then return false end
	end
	--
	return true
end

function BUSH.ContainerAccess.SL(vehicle, part, chr)
	if chr:getVehicle() then return false end
	if not vehicle:isInArea(part:getArea(), chr) then return false end

	local storage = vehicle:getPartById("BUSHStorageLeft")
	local inventoryItem = storage:getInventoryItem()
	if inventoryItem:getFullType() == "Base.Generator" then return false end
	--
	return true
end

function BUSH.ContainerAccess.SR(vehicle, part, chr)
	if chr:getVehicle() then return false end
	if not vehicle:isInArea(part:getArea(), chr) then return false end
	local StorageLid3 = vehicle:getPartById("StorageLid3")
	if StorageLid3 and StorageLid3:getDoor() then
		if not StorageLid3:getInventoryItem() then return true end
		if not StorageLid3:getDoor():isOpen() then return false end
	end
	--
	return true
end

function BUSH.ContainerAccess.Seat(vehicle, part, chr)
	if not part:getInventoryItem() then return false; end
	local seat = part:getContainerSeatNumber()
	if seat ~= -1 and vehicle:getCharacter(seat) then return false
	end
	if chr:getVehicle() == vehicle then
		return vehicle:canSwitchSeat(vehicle:getSeat(chr), seat) and
				not vehicle:getCharacter(seat)
	elseif chr:getVehicle() then return false
	end
end